#include once "display.bi"
#include once "mathf.bi"
#include once "voxel.bi"
#include once "image.bi"


extern Display as ndisplay.Display_Struct
using nDisplay
using nVoxel
using nMathf
using nImage

dim as Display_Struct Display
dim as Light_Struct Light

CreateGLWindow( 1024,768, 32,0,2,0 )
init_light( 0, Light, type(.25,.25,.25,1), type(.65,.65,.65,1), type(.95,.95,.95,1), type(300,1500,300,1), type(0,0,0) )

dim as font_struct myFont = 16
myFont.Load( "assets/textures/fonts/font1.png" )

dim as texture_struct texture()
dim as double lTime = timer, dTime, rot, fpsTime, frame = 1
dim as VoxelObject voxelThing(1 to 30)
dim as integer fpscounter
dim as string fps
dim as vec3f pnt(7), nrm(5)
dim as integer ind(5, 3)
dim as matrix nMatrix


load_texture( "assets/textures/grass.png", texture(), 0 )

for i as integer = 0 to 7
	read pnt(i).x, pnt(i).y, pnt(i).z
next

for f as integer = 0 to 5
	for pt as integer = 0 to 3
		read ind(f,pt)
	next
next

for f as integer = 0 to 5
	read nrm(f).x, nrm(f).y, nrm(f).z
next



dim as string tString

'a rotation matrix to orient the model upright
nMatrix.LoadIdentity()
nMatrix.Rotate(90,0,0)

'read in the voxel files
for id as integer = 1 to 30

	if id<10 then
		tString = "assets/voxels/ForestGuard/Walk/walk_00000" & id & ".vox"
	else
		tString = "assets/voxels/ForestGuard/Walk/walk_0000" & id & ".vox"
	end if

	loadvoxelobject( tString, voxelThing(id) )

	dim as vec3f cent
	dim as single yMax=-32767
	for i as integer = lbound(voxelThing(id).voxels) to ubound(voxelThing(id).voxels)

		dim as vec3f temp = vec3f( voxelThing(id).voxels(i).x, voxelThing(id).voxels(i).y, voxelThing(id).voxels(i).z )*nMatrix
		voxelThing(id).voxels(i).x = temp.x
		voxelThing(id).voxels(i).y = temp.y
		voxelThing(id).voxels(i).z = temp.z

		cent+= vec3f( voxelThing(id).voxels(i).x, voxelThing(id).voxels(i).y, voxelThing(id).voxels(i).z )

		if voxelThing(id).voxels(i).y>yMax then
			yMax = voxelThing(id).voxels(i).y
		endif

	next

	'center x and z, but rest y on the ground
	cent/=(ubound(voxelThing(id).voxels)-lbound(voxelThing(id).voxels))
	for i as integer = lbound(voxelThing(id).voxels)  to ubound(voxelThing(id).voxels)
		voxelThing(id).voxels(i).x-=cent.x
		voxelThing(id).voxels(i).y-=cent.y*2
		voxelThing(id).voxels(i).z-=cent.z
	next

	'generate the display lists
	voxelThing(id).dList = glGenLists(1)
	glNewList( voxelThing(id).dList, GL_COMPILE )

	glBegin(GL_QUADS)
	
	for i as integer = 1  to ubound(voxelThing(id).voxels)

		dim as integer ci = voxelThing(id).voxels(i).ci

		glColor4ub( voxelThing(id).colTable(ci).r, voxelThing(id).colTable(ci).g, voxelThing(id).colTable(ci).b, 8 )
		
		
		dim as vec3f vp = vec3f( voxelThing(id).voxels(i).x, voxelThing(id).voxels(i).y, voxelThing(id).voxels(i).z )

		for f as integer = 0 to 5
			glNormal3fv( @nrm(f).x )
			for pt as integer = 0 to 3
				dim as vec3f np = pnt(ind(f,pt)) + vp
				glVertex3fv( @np.x )
			next
		next

	next
	glEnd()
	glEndList()


next



dim as vec3f posit
lTime = timer


do
	
	'for time based movement''' dTime = delta time
	dTime = timer-lTime
	lTime = timer
	rot+=dTime*30

	'aniamtion frame counter
	frame+=dTime*30
	if int(frame)>30 then
		frame = 1
	end if

	'clear the opengl buffers
	glClear( GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT )

	'set the camera away a bit and look at the character's position
	glMatrixMode(GL_MODELVIEW)
	glLoadIdentity()
	gluLookAt( -150,250,150, posit.x, posit.y, posit.z, 0,1,0)
	glLightFv( GL_LIGHT0, GL_POSITION, @Light.position.x )

	'draw a temporary ground plane...
	glEnable(GL_TEXTURE_2D)
	glBindTexture( GL_TEXTURE_2D, texture(0).img )
	glColor3f(.65,.65,.65)
	glBegin(GL_QUADS)
	glNormal3f(0,1,0)
	
	glTexcoord2f(1,1)
	glVertex3f(2000,0,2000)
	
	glTexcoord2f(1,-1)
	glVertex3f(2000,0,-2000)
	
	glTexcoord2f(-1,-1)
	glVertex3f(-2000,0,-2000)
	
	glTexcoord2f(-1,1)
	glVertex3f(-2000,0,2000)
	glEnd()

	'generate the matrix for the shadopw projection
	dim as vec4f plane
	plane = calc_plane( vec3f(200,0,200), vec3f(200,0,-200), vec3f(-200,0,-200) )
	dim as matrix pMatrix, tMatrix
	pMatrix.LoadIdentity()
	tMatrix = pMatrix.PlanarProjection( Light.Position, plane )
	
	'translate/rotate the character's position
	nMatrix.LoadIdentity()
	nMatrix.Translate(posit)
	nMatrix.Rotate( 0, int(rot), 0 )
	posit+=nMatrix.Right*csng(dTime*140)
	
	
	'draw the shadow using a planar projection matrix
	glDisable(GL_TEXTURE_2D)
	glEnable( GL_LIGHTING )
	glEnable( GL_LIGHT0 )
	dim as vec4f zero
	gllightfv( GL_LIGHT0, GL_AMBIENT, @zero.x )
	gllightfv( GL_LIGHT0, GL_DIFFUSE, @zero.x )
	gllightfv( GL_LIGHT0, GL_SPECULAR, @zero.x )
	glDisable(GL_DEPTH_TEST)
	glDisable( GL_COLOR_MATERIAL )
	glPushMatrix()
	glMultMatrixf(tMatrix)
	glMultMatrixf(nMatrix)
	glCallList(voxelThing(int(frame)).dList)
	glPopMatrix()
	
	
	
	'draw the character
	gllightfv( GL_LIGHT0, GL_AMBIENT, @light.ambient.r )
	gllightfv( GL_LIGHT0, GL_DIFFUSE, @light.diffuse.r )
	gllightfv( GL_LIGHT0, GL_SPECULAR, @light.specular.r )
	glEnable( GL_COLOR_MATERIAL )
	glEnable(GL_DEPTH_TEST)
	glDepthFunc( GL_LEQUAL )
	glDisable(GL_BLEND)
	glMultMatrixf(nMatrix)
	glCallList(voxelThing(int(frame)).dList)

	'fps...
	fpscounter+=1
	if timer>fpsTime then
		fpsTime=timer+1
		fps = "FPS = " & str(fpscounter)
		fpscounter=0
	endif

	'print output in this block
	myFont.oBegin()
	myFont.oPrint( fps, display.w2-len(fps)*5, display.h-16, 1,1,1, 20 )
	dim as string tString = "Animation frame #" & int(frame)
	myFont.oPrint( tString, display.w2-len(tString)*5, display.h-32, 1,1,1, 20 )
	myFont.oEnd()

	sleep 3,1
	flip

loop until multikey(FB.SC_ESCAPE)


for id as integer = lbound(voxelThing) to ubound(voxelThing)

	glDeleteLists( voxelThing(id).dList, 1 )
	
next



'data for cube, indices and normals
data -.5,  .5, .5
data -.5, -.5, .5
data  .5, -.5, .5
data  .5,  .5, .5

data -.5,  .5, -.5
data -.5, -.5, -.5
data  .5, -.5, -.5
data  .5,  .5, -.5


data 0,1,2,3
data 0,3,7,4
data 4,7,6,5
data 1,5,6,2
data 0,4,5,1
data 3,2,6,7


data  0, 0, 1
data  0,-1, 0
data  0, 0,-1
data  0, 1, 0
data -1, 0, 0
data  1, 0, 0
