#include once "voxel.bi"

extern Display as ndisplay.Display_Struct

namespace nVoxel

	function loadvoxelobject( byref voxfile as string, byref vObject as VoxelObject ) as integer
		
		dim as integer fNum
		dim as integer f, x, y, z, subsample
		dim as integer FileLength
		dim FileByte as ubyte
		dim Version as integer
		dim ChunkID as string
		dim CurrentChunk as chunk
		dim CurVoxel as VoxelDataVOX
		dim as uinteger sizeX, sizeY, sizeZ, numVoxels = 0, voxnum, SpeedTest, edgeClr
		
		dim as integer lowestX = 999
		dim as integer lowestY = 999
		dim as integer lowestZ = 999
		dim as integer highestX = 0
		dim as integer highestY = 0
		dim as integer highestZ = 0
		dim as integer negatory
		dim voxelspriteclr() as ubyte
		redim voxelspriteclr(512,512,512) as ubyte
		dim ColorIndex(256) as ColorData
		Dim ClrIndxFull(256) As uinteger
			
			
			
			
		'if numVoxels = 0 then
		fnum = freefile
		open voxfile for binary as #fNum
		if err>0 then 
			print #display.debugout, "Error opening the file":
			return 0
		endif
		
		FileLength = filelen(voxfile)
		
		
		'--------------------------------------------------------------------
		' Load in MagicaVoxel Default Color Palette    NOT WORKING
		'--------------------------------------------------------------------
		'dim hextext as string

		'    Restore MagicaVoxelDefaultPalette
		'    print "reading in DEFAULT Color Index!"
		'    for x = 1 to 255
		'        read hextext : ClrIndxFull(x) = ValInt(ucase$(hextext))
		'    next x

		' read header
		dim Magic as string = "1234"
		
		get #fNum,1, Magic
		print #display.debugout, "Magic Header ID = (";Magic;")"
		if Magic = "VOX " then
			print #display.debugout, "It's a MagicaVoxel file!  It is Sized =";FileLength
			get #fNum,, Version
			print #display.debugout, "Version: ";Version
			print #display.debugout, " "

			do until eof(fnum)
				get #fNum,, CurrentChunk
				ChunkId = ""
				for x = 1 to 4
					ChunkId = ChunkId + chr$(CurrentChunk.idub(x))
				next x
				print #display.debugout, "ID =";ChunkId
				print #display.debugout, "Size =";CurrentChunk.size
				print #display.debugout, "ChildChunks =";CurrentChunk.ChildChunks

				select case ChunkId
					case "MAIN"
					case "SIZE"
						'                    print "loading SIZE Chunk..." : sleep
						get #fNum,, sizeX
						get #fNum,, sizeY
						get #fNum,, sizeZ
						if (sizeX > 32) and (sizeY > 32) then subsample = 1
						' just read filler bytes?
						if CurrentChunk.size-12 > 0 then  'excess????
							for x = 1 to CurrentChunk.size - (4 * 3) ' the 12 = 4*3 is the above x,y,z integers
								get #fNum,, FileByte
							next x
						end if
						print #display.debugout, " "

					case "RGBA" 'reading in Color Index
						'                    print "loading RGBA Chunk..." : sleep
						for x = 1 to 256
							get #fNum,, ColorIndex(x)
							ClrIndxFull(x) = rgba(ColorIndex(x).r, ColorIndex(x).g, ColorIndex(x).b, ColorIndex(x).a)
							vObject.colTable(x) = ColorIndex(x)
						next x

					case "XYZI" ' YAY! Voxel info
						'                    print "loading XYZI Chunk..." : sleep
						get #fNum,, numVoxels
						redim vObject.Voxels(1 to numVoxels)
						
						print #display.debugout, "Voxel count " & numVoxels 
						
						for x = 1 to numVoxels
							get #fNum,, CurVoxel
							vObject.Voxels(x).x   = CurVoxel.x
							if vObject.Voxels(x).x < lowestX then lowestX = vObject.Voxels(x).x
							if vObject.Voxels(x).x > highestX then highestX = vObject.Voxels(x).x

							vObject.Voxels(x).y   = sizeY-CurVoxel.y  ' weird inverted thing
							if vObject.Voxels(x).y < lowestY then lowestY = vObject.Voxels(x).y
							if vObject.Voxels(x).y > highestY then highestY = vObject.Voxels(x).y

							vObject.Voxels(x).z   = sizeZ-CurVoxel.z 'sizeX-CurVoxel.z
							if vObject.Voxels(x).z < lowestZ then lowestZ = vObject.Voxels(x).z
							if vObject.Voxels(x).z > highestZ then highestZ = vObject.Voxels(x).z

							vObject.Voxels(x).ci  = CurVoxel.ci
							vObject.Voxels(x).rot = 0

							' save it into the old '3d array' method for testing EXEPT this is the index!!! Change to RGBA asap
							voxelspriteclr(vObject.Voxels(x).x, vObject.Voxels(x).y, vObject.Voxels(x).z) = vObject.Voxels(x).ci
						next x

					case else   'always crap at end of file for some reason...

						exit do
				end select
			loop
		else
			'--------------------------------------------------------------------
			'           Load in POLY2VOX .VOX file
			'--------------------------------------------------------------------
			print #display.debugout, "We think it is a Poly2Vox file..."
			get #fNum,1, sizeX
			get #fNum,, sizeY
			get #fNum,, sizeZ
			numVoxels = sizeX*sizeY*sizeZ
			redim vObject.Voxels(1 to numVoxels)
			print #display.debugout, "Size is (";sizeX;",";sizeY;",";sizeZ;")"
			print #display.debugout, "(";numVoxels;")"
			print #display.debugout, "Now getting voxels..."
			voxnum = 1 : negatory = 0
			for x = 0 to (sizeX-1)
				for y = 0 to (sizeY-1)
					for z = 0 to (sizeZ-1)
						get #fNum,, FileByte
						numVoxels = numVoxels-1
						if FileByte = 0 then
							' is INSIDE VOXEL
						else
							if Filebyte = 255 then
								' is VOID VOXEL
							else
								vObject.Voxels(voxnum).x   = z
								vObject.Voxels(voxnum).y   = y  ' need to switch z&y, y&x
								vObject.Voxels(voxnum).z   = sizeX - x
								vObject.Voxels(voxnum).rot = 0
								vObject.Voxels(voxnum).ci = FileByte

								if vObject.Voxels(voxnum).x < lowestX then lowestX = vObject.Voxels(x).x
								if vObject.Voxels(voxnum).x > highestX then highestX = vObject.Voxels(x).x

								if vObject.Voxels(voxnum).y < lowestY then lowestY = vObject.Voxels(x).y
								if vObject.Voxels(voxnum).y > highestY then highestY = vObject.Voxels(x).y

								if vObject.Voxels(voxnum).z < lowestZ then lowestZ = vObject.Voxels(x).z
								if vObject.Voxels(voxnum).z > highestZ then highestZ = vObject.Voxels(x).z


								voxelspriteclr(vObject.Voxels(voxnum).x, vObject.Voxels(voxnum).y, vObject.Voxels(voxnum).z) = vObject.Voxels(voxnum).ci

								if (vObject.Voxels(voxnum).x<0) or (vObject.Voxels(voxnum).y<0) or (vObject.Voxels(voxnum).z<0) then
									negatory = negatory + 1
								end if

								voxnum = voxnum + 1
							end if
						end if
					next z
				next y
			next x

			print #display.debugout, "Got ";voxnum;" voxels! "
			print #display.debugout, "Now getting color palette..."

			for x = 0 to 255
				get #fNum,, ColorIndex(x).r
				get #fNum,, ColorIndex(x).g
				get #fNum,, ColorIndex(x).b
				ClrIndxFull(x) = rgba(ColorIndex(x).r shl 2, ColorIndex(x).g shl 2, ColorIndex(x).b shl 2, 255)
			next x
			
			print #display.debugout, "Got color palette!"
			numVoxels = voxnum
		end if
		close #fNum

		'end if
	
	return 1
	
	end function

end namespace
